searchData={"content_type":"text/markdown","items":[{"doc":"A Markdown template engine for Phoenix. It also lets you (optionally) embed EEx tags to be evaulated on the server.\n\n> Powered by [Earmark](https://github.com/pragdave/earmark)","ref":"PhoenixSolidMarkdown.html","title":"PhoenixSolidMarkdown","type":"module"},{"doc":"1. Add `{:phoenix_markdown, \"~> 1.0\"}` to your deps in `mix.exs`.\n  2. Add the following to your Phoenix `config/config.exs`\n\n     ```elixir\n    config :phoenix, :template_engines,\n      md: PhoenixMarkdown.Engine\n     ```\n\n    If you are also using the [phoenix_haml](https://github.com/chrismccord/phoenix_haml) engine,\n    then it should look like this:\n     ```elixir\n    config :phoenix, :template_engines,\n      haml: PhoenixHaml.Engine,\n      md:   PhoenixMarkdown.Engine\n     ```\n\n\n  3. Use the `.html.md` extensions for your templates.","ref":"PhoenixSolidMarkdown.html#module-usage","title":"Usage - PhoenixSolidMarkdown","type":"module"},{"doc":"Add md extension to Phoenix live reload in `config/dev.exs`\n\n```elixir\n  config :hello_phoenix, HelloPhoenix.Endpoint,\n    live_reload: [\n      patterns: [\n        ~r{priv/static/.*(js|css|png|jpeg|jpg|gif|svg)$},\n        ~r{web/views/.*(ex)$},\n        ~r{web/templates/.*(eex|md)$}\n      ]\n    ]\n```\n\nIf you are also using the [phoenix_haml](https://github.com/chrismccord/phoenix_haml) engine,\nthen the pattern should look like this:\n\n```elixir\n  config :hello_phoenix, HelloPhoenix.Endpoint,\n    live_reload: [\n      patterns: [\n        ~r{priv/static/.*(js|css|png|jpeg|jpg|gif|svg)$},\n        ~r{web/views/.*(ex)$},\n        ~r{web/templates/.*(eex|haml|md)$}\n      ]\n    ]\n```","ref":"PhoenixSolidMarkdown.html#module-optional","title":"Optional - PhoenixSolidMarkdown","type":"module"},{"doc":"You can configure phoenix_markdown via two seperate configuration blocks.\n\nThe first one is,\nliterally, the options that will be passed to Earmark as it renders the markdown into html.\n\n```elixir\n  config :phoenix_markdown, :earmark, %{\n    gfm: true,\n    breaks: true\n  }\n```\n\nPlease read the [Earmark Documentation](https://hexdocs.pm/earmark/Earmark.html#as_html!/2) to understand\nthe options that can go here.\n\nThe Earmark options set here apply to all .md template files. If anybody has a good idea on how to pass\nper-file options to a template complier, I'm open to suggestions.","ref":"PhoenixSolidMarkdown.html#module-optional-earmark-configuration","title":"Optional Earmark Configuration - PhoenixSolidMarkdown","type":"module"},{"doc":"The second configuration block is where you indicate if you want to evaluate EEx tags on the server\nor escape them Earmark. The default is to escape in Earmark.\n\nExample of markdown content with a server-side tag:\n\n```markdown","ref":"PhoenixSolidMarkdown.html#module-optional-server-tags-configuration","title":"Optional Server Tags Configuration - PhoenixSolidMarkdown","type":"module"},{"doc":"<%= 11 + 2 %>\n\n  After the server-side content\n```\n\nTo turn on server-side eex tags, set the `:server_tags` configuration option.\n\n```elixir\n  config :phoenix_markdown, :server_tags, :all\n```\n\nThe options to turn on server tags are `:all`, `:only` and `:except`. Anything else (or not setting it at all)\nleaves the tags escaped in Markdown.\n\n* `:all` evaluates all server tags in all markdown files.\n* `:only` Only files that match the pattern or patterns will be evaluated. \n  This pattern can be any of:\n    * The name of the final html file: `\"sample.html\"`\n    * The full path of the template file: `\"lib/sample_web/templates/page/sample.html.md\"`\n    * A path with wildcards: `\"**/page/**\"`. This is nice as it would evaluate all files in a single directory.\n    * A regex against the path: `~r/.+%%.+/`. This allows you to use a character sequence in the name as a per-file (or path) flag saying if it should be evaluated.\n* `:except` Only files that do NOT match the pattern or patterns will be evaluated.\n  This pattern can be any of:\n    * The name of the final html file: `\"sample.html\"`\n    * The full path of the template file: `\"lib/sample_web/templates/page/sample.html.md\"`\n    * A path with wildcards: `\"**/page/**\"`. This is nice as it would prevent evaluation of all files in a single directory.\n    * a regex against the path: `~r/.+%%.+/`. This allows you to use a character sequence in the name as a per-file (or path) flag saying if it not should be evaluated.\n\nBoth the `:only` and `:except` options accept either a single pattern, or a list of patterns.\n\n```elixir\n  config :phoenix_markdown, :server_tags, only: ~r/.+%%.+/\n```\nor...\n\n```elixir\n  config :phoenix_markdown, :server_tags, only: [~r/.+%%.+/, \"some_file.html\"]\n```","ref":"PhoenixSolidMarkdown.html#module-before-server-side-content","title":"Before server-side content - PhoenixSolidMarkdown","type":"module"},{"doc":"There are no generators for phoenix_markdown since they wouldn't make sense. You can embed server-side\ntags if you turn them on in the configuration, but otherwise just keep it static and refer to it from\na *.eex template.\n\nLike this:\n```elixir\n  <% render(\"some_markdown.html\") %>\n```\n\n[Markdown](https://daringfireball.net/projects/markdown/) is intended to be written by a human\nin any simple text editor ( or a fancy one like [iA Writer](https://ia.net/writer) ). Just create\na file with the `.html.md` extension and drop it into the appropriate templates folder in your\nphoenix application. Then you can use it just like any other template.","ref":"PhoenixSolidMarkdown.html#module-generators","title":"Generators - PhoenixSolidMarkdown","type":"module"},{"doc":"Render the Liquid template to html.\n\nIf the input template contains no Liquid tags, convert it to HTML at compile\ntime. Otherwise, the returned macro will invoke Solid.render! at runtime to perform\nthe coversion after evaluating the tags.","ref":"PhoenixSolidMarkdown.html#solid_render/1","title":"PhoenixSolidMarkdown.solid_render/1","type":"function"},{"doc":"a single public function (compile) that Phoenix uses to compile incoming templates. You should not need to call it yourself.","ref":"PhoenixSolidMarkdown.Engine.html","title":"PhoenixSolidMarkdown.Engine","type":"module"},{"doc":"Callback implementation for `Phoenix.Template.Engine.compile/2`\n\nPrecompiles the template at `path` into a function defintion, using the Solid and Earmark engines.","ref":"PhoenixSolidMarkdown.Engine.html#compile/2","title":"PhoenixSolidMarkdown.Engine.compile/2","type":"function"},{"doc":"* `path` path to the template being compiled\n  * `name` name of the template being compiled","ref":"PhoenixSolidMarkdown.Engine.html#compile/2-parameters","title":"Parameters - PhoenixSolidMarkdown.Engine.compile/2","type":"function"},{"doc":"a single public function (compile) that Phoenix uses to compile incoming templates. You should not need to call it yourself.","ref":"PhoenixSolidMarkdown.SolidEngine.html","title":"PhoenixSolidMarkdown.SolidEngine","type":"module"},{"doc":"Callback implementation for `Phoenix.Template.Engine.compile/2`\n\nPrecompiles the template at `path` into a function defintion, using the Solid engine.","ref":"PhoenixSolidMarkdown.SolidEngine.html#compile/2","title":"PhoenixSolidMarkdown.SolidEngine.compile/2","type":"function"},{"doc":"* `path` path to the template being compiled\n  * `name` name of the template being compiled","ref":"PhoenixSolidMarkdown.SolidEngine.html#compile/2-parameters","title":"Parameters - PhoenixSolidMarkdown.SolidEngine.compile/2","type":"function"},{"doc":"# Markdown Template Engine for Phoenix\n\nA Markdown template engine for [Phoenix](https://www.phoenixframework.org/). It also lets you (optionally) embed Liquid tags to be evaluated on the server.\n\n> Powered by [Earmark](https://github.com/pragdave/earmark) and [Solid](https://github.com/edgurgel/solid)\n\n> Based on [phoenix_markdown](https://github.com/boydm/phoenix_markdown)","ref":"readme.html","title":"Markdown Template Engine for Phoenix","type":"extras"},{"doc":"1. Add `{:phoenix_solid_markdown, \"~> 0.1.0-rc.0\"}` to your deps in `mix.exs`.\n2. Add the following to your Phoenix `config/config.exs`\n```elixir\n  config :phoenix, :template_solid_engines,\n    md:     PhoenixSolidMarkdown.Engine,\n    liquid: PhoenixSolidMarkdown.SolidEngine\n```\n\nIf you are also using the [phoenix_markdown](https://github.com/boydm/phoenix_markdown) engine, then it should look like this:\n```elixir\n  config :phoenix, :template_engines,\n    md:     PhoenixMarkdown.Engine,\n    mds:    PhoenixSolidMarkdown.Engine,\n    liquid: PhoenixSolidMarkdown.SolidEngine\n```\n\n3. Use the `.html.md` or `.html.mds` or `.html.liquid` extensions for your templates.","ref":"readme.html#usage","title":"Usage - Markdown Template Engine for Phoenix","type":"extras"},{"doc":"Add md extension to Phoenix live reload in `config/dev.exs`\n\n```elixir\n  config :hello_phoenix, HelloPhoenix.Endpoint,\n    live_reload: [\n      web_console_logger: true,\n      patterns: [\n        ~r\"priv/static/(?!uploads/).*(js|css|png|jpeg|jpg|gif|svg)$\",\n        ~r\"priv/gettext/.*(po)$\",\n        ~r\"lib/video_site_web/(?:controllers|live|components|router)/?.*\\.(ex|heex|md|mds|liquid)$\"\n      ]\n    ]\n```","ref":"readme.html#optional","title":"Optional - Markdown Template Engine for Phoenix","type":"extras"},{"doc":"You can configure phoenix_solid_markdown via one configuration block,\nwhich will be passed to Earmark as it renders the markdown into html.\n\n```elixir\n  config :phoenix_solid_markdown, :earmark, %{\n    gfm: true,\n    breaks: true\n  }\n```\n\nPlease read the [Earmark Documentation](https://hexdocs.pm/earmark/Earmark.html#as_html!/2) to understand\nthe options that can go here.","ref":"readme.html#optional-earmark-configuration","title":"Optional Earmark Configuration - Markdown Template Engine for Phoenix","type":"extras"},{"doc":"By default Earmark replaces some characters with prettier UTF-8 versions. For\nexample, single and double quotes are replaced with left- and right-handed\nversions.  This may break any server tag which contains a prettified character\nsince EEx cannot interpret them as intended. To fix this, disable smartypants\nprocessing and escaping.\n\n```elixir\n  config :phoenix_solid_markdown, :earmark, %{\n    smartypants: false,\n    escape: false\n  }\n```\n\n[Markdown](https://daringfireball.net/projects/markdown/) is intended to be written by a human\nin any simple text editor ( or a fancy one like [iA Writer](https://ia.net/writer) ). Just create\na file with the `.html.md` extension and drop it into the appropriate templates folder in your\nphoenix application. Then you can use it just like any other template.","ref":"readme.html#unexpected-token-in-server-tags","title":"Unexpected Token in Server Tags - Markdown Template Engine for Phoenix","type":"extras"}],"producer":{"name":"ex_doc","version":"0.38.1"},"proglang":"elixir"}